;;-------------------------------------------------------------------------
;;
;;	mx launcher 1.0.14.0
;;	by adic3x 2010 - 2011
;;
;;-------------------------------------------------------------------------
;;
;;	to do:
;;
;;	0. Correct current directory string lenght
;;
;;-------------------------------------------------------------------------

;;-------------------------------------------------------------------------
format PE GUI 4.0

	include 'D:\fasmw168\INCLUDE\win32wx.inc'

;;-------------------------------------------------------------------------
section '.text' code readable writeable executable

;;-------------------------------------------------------------------------
;; code
	xor	ebx,			ebx
	push	ebx				;; ebx ---> ExitProcess

	push	_xProcInfo
	push	_xStartInfo
	push	ebx
	push	ebx
	push	CREATE_SUSPENDED
	push	ebx
	push	ebx
	push	ebx
	invoke	GetCommandLineW
	push	eax
	push	_sWar3				;; ---> CreateProcessW

	cmp	word [eax],		0022h
	jne	@f
	add	eax,			02h

		;;----------------
		;; set current directory
		@@:
		mov	esi,			eax
		mov	edi,			_sCurDir
		push	edi				;; ---> SetCurrentDirectoryW
		.SetCurrDirr:
		movsw

		cmp	word [esi],		005ch
		jne	@f
		mov	ebp,			edi
		jmp	.SetCurrDirr

		@@:
		cmp	dword [esi],		0065002eh	;; .e
		jne	.SetCurrDirr
		cmp	dword [esi + 04h],	00650078h	;; xe
		jne	.SetCurrDirr
		cmp	word [esi + 08h],	0022h		;; "
		je	@f
		cmp	word [esi + 08h],	0020h		;; bs
		jne	.SetCurrDirr

		@@:
		mov	word [ebp], 		00h
		call	[SetCurrentDirectoryW]
		;;----------------

		;;----------------
		;; check mpq version
		mov	edi,			_sName_00
		lea	esi,			[edi + 01h]

		@@:
		invoke	GetFileAttributesA,	_sName
		inc	eax
		jnz	.lMpqEnd

		dec	byte [esi]	
		cmp	byte [esi],		2fh
		jne	@b
		mov	byte [esi],		39h
		dec	byte [edi]
		cmp	byte [edi], 		2fh
		jne	@b

		add	esp,			28h	;; go to error
		;;----------------

	;;----------------
	;; errors
	mov	eax,			_sErr_01

	.lErr:
	invoke	MessageBoxW,		ebx, eax, _sError, 30h
	call	[ExitProcess]

	.lErrEX:
	mov	eax,			_sErr_00
	jmp	.lErr
	;;----------------

	;;----------------
	.lMpqEnd:
	call	[CreateProcessW]
	dec	eax
	jne	.lErrEX
	;;----------------

	;;----------------
	;; set proc addr
	mov	eax,			[GetModuleHandleW]
	mov	[_fGetModuleHandle],	eax
	mov	eax,			[GetProcAddress]
	mov	[_fGetProcAddress],	eax
	mov	eax,			[ExitThread]
	mov	[_fExitThread],		eax
	mov	eax,			[VirtualProtect]
	mov	[_fVirtualProtect],	eax
	;;----------------

	;;----------------
	;; load mpq to war
	mov	edi,			dword [_xProcInfo]

	invoke	VirtualAllocEx,		edi, ebx, 50h, MEM_COMMIT + MEM_RESERVE + MEM_TOP_DOWN, PAGE_EXECUTE_READWRITE

	push	MEM_RELEASE
	push	ebx
	push	eax
	push	edi

	push	ebx
	push	ebx
	push	eax
	push	eax
	push	7fh
	push	ebx
	push	edi

	push	ebx
	push	_LDataEnd - _lDataStart
	push	_lDataStart
	push	eax
	push	edi

	call	[WriteProcessMemory]

	call	[CreateRemoteThread]

	invoke	WaitForSingleObject,	eax, 0ffffffffh

	call	[VirtualFreeEx]

	push	[_xProcInfo + PROCESS_INFORMATION.hThread]	;; ---> ResumeThread
	;;----------------

	;;----------------
	;; get and check version
	mov	esi,			_sWar3
	mov	edi,			_xVer_war
	call	_lGetFileVer

	mov	esi,			_sGame
	mov	edi,			_xVer_game
	call	_lGetFileVer

	mov	eax,			_xVer_war

		;;----------------
		;; 24a
		cmp	dword [eax],			00010018h	;; 1.24
		jne	@f
		cmp	dword [eax + 04h],		000018e4h	;; 0.6372
		jne	@f
		cmp	dword [eax + 08h],		00010018h	;; 1.24
		jne	@f	
		cmp	dword [eax + 0ch],		000018e4h	;; 0.6372
		je	.lAddNatives
		;;----------------

		;;----------------
		;; 24b
		@@:
		cmp	dword [eax],			00010018h	;; 1.24
		jne	@f
		cmp	dword [eax + 04h],		000118e6h	;; 1.6374
		jne	@f
		cmp	dword [eax + 08h],		00010018h	;; 1.24
		jne	@f	
		cmp	dword [eax + 0ch],		000118e6h	;; 1.6374

		mov	dword [_xNativeRegAddr_00],	_xNatineReg_24b
		mov	dword [_xNativeRegAddr_01],	_xNatineReg_24b

		jmp	.lAddNatives
		;;----------------

		;;----------------
		;; 24c
		@@:
		cmp	dword [eax],			00010018h	;; 1.24
		jne	@f
		cmp	dword [eax + 04h],		000218eah	;; 2.6378
		jne	@f
		cmp	dword [eax + 08h],		00010018h	;; 1.24
		jne	@f	
		cmp	dword [eax + 0ch],		000218eah	;; 2.6378

		mov	dword [_xNativeRegAddr_00],	_xNatineReg_24c
		mov	dword [_xNativeRegAddr_01],	_xNatineReg_24c

		jmp	.lAddNatives
		;;----------------

		;;----------------
		;; 24d
		@@:
		cmp	dword [eax],			00010018h	;; 1.24
		jne	@f
		cmp	dword [eax + 04h],		000318f0h	;; 3.6384
		jne	@f	
		cmp	dword [eax + 08h],		00010018h	;; 1.24
		jne	@f	
		cmp	dword [eax + 0ch],		000318f0h	;; 3.6384
		jne	@f

		mov	dword [_xNatineRegEnd],		_xNatineRegEnd_24d
		mov	dword [_xNativeRegAddr_00],	_xNatineReg_24d
		mov	dword [_xNativeRegAddr_01],	_xNatineReg_24d

		jmp	.lAddNatives
		;;----------------

		;;----------------
		;; 24e
		@@:
		cmp	dword [eax],			00010018h	;; 1.24
		jne	@f
		cmp	dword [eax + 04h],		000418f3h	;; 4.6387
		jne	@f	
		cmp	dword [eax + 08h],		00010018h	;; 1.24
		jne	@f	
		cmp	dword [eax + 0ch],		000418f3h	;; 4.6387
		jne	@f

		mov	dword [_xNatineRegEnd],		_xNatineRegEnd_24e
		mov	dword [_xNativeRegAddr_00],	_xNatineReg_24e
		mov	dword [_xNativeRegAddr_01],	_xNatineReg_24e

		jmp	.lAddNatives
		;;----------------

		;;----------------
		;; 25b
		@@:
		cmp	dword [eax],			00010019h	;; 1.25
		jne	@f
		cmp	dword [eax + 04h],		000118fdh	;; 1.6397
		jne	@f	
		cmp	dword [eax + 08h],		00010019h	;; 1.25
		jne	@f	
		cmp	dword [eax + 0ch],		000118fdh	;; 4.6397
		jne	@f

		mov	dword [_xNatineRegEX],			455dd0b9h		;; just magic
		mov	dword [_hGameDllLoad],			_hGameDllLoad_25b
		mov	dword [_xNatineRegEnd],			_xNatineRegEnd_25b
		mov	dword [_xNativeRegAddr_00],		_xNatineReg_25b
		mov	dword [_xNativeRegAddr_01],		_xNatineReg_25b
		mov	dword [_xGameDllInCode_01],		_xGameDllInCode_01_25b
		mov	dword [_xGameDllInCode_02],		_xGameDllInCode_02_25b
		mov	dword [_xGameDllInCode_00 + 01h],	_xGameDllInCode_01_25b - _hGameDllLoad_25b - 05h
		mov	dword [_lGameLibCorrect],		_xGameLib_25b

		jmp	.lAddNatives
		;;----------------

		;;----------------
		;; 26a
		@@:
		cmp	dword [eax],			0001001ah	;; 1.26
		jne	@f
		cmp	dword [eax + 04h],		00001901h	;; 0.6401
		jne	@f	
		cmp	dword [eax + 08h],		0001001ah	;; 1.26
		jne	@f	
		cmp	dword [eax + 0ch],		00001901h	;; 0.6401
		jne	@f

		mov	dword [_xNatineRegEX],			455dd0b9h		;; just magic
		mov	dword [_hGameDllLoad],			_hGameDllLoad_26a
		mov	dword [_xNatineRegEnd],			_xNatineRegEnd_26a
		mov	dword [_xNativeRegAddr_00],		_xNatineReg_26a
		mov	dword [_xNativeRegAddr_01],		_xNatineReg_26a
		mov	dword [_xGameDllInCode_01],		_xGameDllInCode_01_26a
		mov	dword [_xGameDllInCode_02],		_xGameDllInCode_02_26a
		mov	dword [_xGameDllInCode_00 + 01h],	_xGameDllInCode_01_26a - _hGameDllLoad_26a - 05h
		mov	dword [_lGameLibCorrect],		_xGameLib_26a

		jmp	.lAddNatives
		;;----------------

		;;----------------
		;; error - unsupported version
		@@:
		mov	eax,				_sErr_02
		jmp	.lErr
		;;----------------
	;;----------------

	;;----------------
	;; add natives
	.lAddNatives:
	mov	esi,			dword [_xProcInfo]	;; esi = process handle

	invoke	WriteProcessMemory,	esi, dword [_hGameDllLoad], _xGameDllInCode_00, 07h, ebx
	invoke	WriteProcessMemory,	esi, dword [_xGameDllInCode_01], _xInGameCdrStr, _xInGameCdrEnd - _xInGameCdrStr, ebx
	invoke	WriteProcessMemory,	esi, dword [_xGameDllInCode_02], _lCodeNativeStr, _lCodeNativeEnd - _lCodeNativeStr, ebx

	;;----------------
	;; resume war
	call	[ResumeThread]
	;;----------------

	;;----------------
	;; exit process
	call	[ExitProcess]
	;;----------------

	;;----------------
	;; get file version
	proc _lGetFileVer 	;; esi = str file path, edi - dest
				;; saves ebx


		invoke	GetFileVersionInfoSizeW,	esi, _hBuf
		mov	ebp,				eax

		invoke	GlobalAlloc,	GPTR, eax

		push	eax
		push	ebp
		push	ebx	;; 00h
		push	esi
		mov	esi,			eax	;; esi = mem addr
		call	[GetFileVersionInfoW]

		invoke	VerQueryValueW,		esi, _sVerFXstr, _hBuf + 04h, _hBuf

		push	esi	;; to GlobalFree

		mov	eax,			dword [_hBuf + 04h]
		mov	esi,			dword [eax + 08h]
		mov	dword [edi],		esi
		mov	esi,			dword [eax + 0ch]
		mov	dword [edi+04h],	esi

		call	[GlobalFree]

		retn
	endp
	;;----------------

	;;----------------
	;; injected code
	_xInGameCdrStr			=	$

	_lGameLibCorrect		=	$ + 01h
	push	_xGameLib_24
	call	edi
	pushad

	db	0e8h
	dd	00000000h
	_lCodeStart			=	$
	pop	ebp

	mov	ebx,			00463000h
	add	eax,			1000h
	push	ebx
	mov	esi,			dword [ebx]
	push	PAGE_EXECUTE_READWRITE
	push	0087dff0h
	push	eax
	call	dword [ebp + _fx_VirtualProtect]

	mov	dword [ebx],		esi

	mov	eax,			_xNatineRegEnd_24
	_xNatineRegEnd			=	$ - 04h

	_xNatineRegEX			=	$ + 02h 
	mov	dword [eax],		455d00b9h	;; mov ecx, 00455d00h
	mov	dword [eax + 04h],	00e1ff00h	;; jmp ecx

	popad
	retn

	_fx_VirtualProtect		=	$ - _lCodeStart
	_fVirtualProtect		dd	?

	_xInGameCdrEnd			=	$
	;;----------------

	;;----------------
	;; add natives code
	_lCodeNativeStr			=	$

	push	esi
		db			0e8h
		dd			00000000h

	_lCodeNativeStrEX		=	$
	pop	esi


	mov	eax,			_xNatineReg_24
	_xNativeRegAddr_00		=	$ - 04h
	push	esi
	add	dword [esp],		_sH2I__l
	lea	edx,			[esi + _sH2I_n__l]
	lea	ecx,			[esi + _lFuncEng]
	call	eax

	mov	eax,			_xNatineReg_24
	_xNativeRegAddr_01		=	$ - 04h
	push	esi
	add	dword [esp],		_sI2W__l
	lea	edx,			[esi + _sI2W_n__l]
	lea	ecx,			[esi + _lFuncEng]
	call	eax

	pop	esi
	retn

	_sH2I__l			=	$ - _lCodeNativeStrEX
	_sH2I				db	"(Hhandle;)I", 00h
	_sH2I_n__l			=	$ - _lCodeNativeStrEX
	_sH2I_n				db	"XAT_H2I", 00h

	_sI2W__l			=	$ - _lCodeNativeStrEX
	_sI2W				db	"(I)Hweathereffect;", 00h
	_sI2W_n__l			=	$ - _lCodeNativeStrEX
	_sI2W_n				db	"WTR_I2W", 00h

	_lFuncEng			=	$ - _lCodeNativeStrEX
	mov	eax,			dword [esp + 04h]
	retn

	_lCodeNativeEnd			=	$
	;;----------------

	;;----------------
	;; mpq load code
	_lDataStart			=	$
	mov	esi,			dword [esp + 04h]

	lea	ecx,			[esi + _sxStorm]
	push	ecx

	push	ecx
	call	dword [esi + _fx_GetModuleHandle]

	push	00h
	push	0fh
	lea	ecx,			[esi + _sx_name]
	push	ecx

	push	010ah
	push	eax
	call	dword [esi + _fx_GetProcAddress]

	call	eax

	push	ebx
	call	dword [esi + _fx_ExitThread]

	_sxStorm				=	$-_lDataStart
						du	"storm.dll", 00h
	_sx_name				=	$-_lDataStart
	_sName					db	"mx_"
	_sName_00				db	"99"
	_sName_01				db	".mpq", 00h

	_fx_GetModuleHandle			=	$ - _lDataStart
	_fGetModuleHandle			dd	?
	_fx_GetProcAddress			=	$ - _lDataStart
	_fGetProcAddress			dd	?
	_fx_ExitThread				=	$ - _lDataStart
	_fExitThread				dd	?

	_LDataEnd				=	$
	;;----------------
;;-------------------------------------------------------------------------

;;-------------------------------------------------------------------------
;; import
data import

	library 	kernel32, 'kernel32.dll',\
			user32,	'user32.dll',\
			version, 'version.dll'

	include 	'D:\fasmw168\include\api\kernel32.inc'
	include 	'D:\fasmw168\include\api\user32.inc'

	import		version, \
			GetFileVersionInfoSizeW,	'GetFileVersionInfoSizeW',\
			GetFileVersionInfoW,		'GetFileVersionInfoW',\
			VerQueryValueW,			'VerQueryValueW'

end data
;;-------------------------------------------------------------------------

;;-------------------------------------------------------------------------
;; data

	_sError			du	"Error", 00h
	_sErr_02		du	"Unknown war3.exe and game.dll build", 00h
	_sErr_01		du	"Can't find mx_**.mpq", 00h
	_sErr_00		du	"Can't run " ;; --->
	_sWar3			du	"war3.exe", 00h
	_sGame			du	"game.dll", 00h

	_sVerFXstr		du	005ch, 0000h

	_hGameDllLoad		dd	_hGameDllLoad_24
	_xGameDllInCode_00	db	0e8h
				dd	_xGameDllInCode_01_24 - _hGameDllLoad_24 - 05h	;; addr offset
				db	90h, 90h

	_xGameDllInCode_01	dd	_xGameDllInCode_01_24
	_xGameDllInCode_02	dd	_xGameDllInCode_02_24

		;;----------------
		;; version table

		;; load game.dll addr
		_hGameDllLoad_24		=	00401303h
		_hGameDllLoad_24a		=	00401303h
		_hGameDllLoad_24b		=	00401303h
		_hGameDllLoad_24c		=	00401303h
		_hGameDllLoad_24d		=	00401303h
		_hGameDllLoad_24e		=	00401303h
		_hGameDllLoad_25b		=	004013cbh	;; diff
		_hGameDllLoad_26a		=	004013cbh	;; diff

		;; free space to inject new native
		;;
		;; 1 - free code addr
		;; 2 - real native code
		_xGameDllInCode_01_24		=	00455a00h
		_xGameDllInCode_02_24		=	00455d00h
		_xGameDllInCode_01_24a		=	00455a00h
		_xGameDllInCode_02_24a		=	00455d00h
		_xGameDllInCode_01_24b		=	00455a00h
		_xGameDllInCode_02_24b		=	00455d00h
		_xGameDllInCode_01_24c		=	00455a00h
		_xGameDllInCode_02_24c		=	00455d00h
		_xGameDllInCode_01_24d		=	00455a00h
		_xGameDllInCode_02_24d		=	00455d00h
		_xGameDllInCode_01_24e		=	00455a00h
		_xGameDllInCode_02_24e		=	00455d00h
		_xGameDllInCode_01_25b		=	00455ad0h	;; diff
		_xGameDllInCode_02_25b		=	00455dd0h	;; diff
		_xGameDllInCode_01_26a		=	00455ad0h	;; diff
		_xGameDllInCode_02_26a		=	00455dd0h	;; diff

		;; game.dll - str
		_xGameLib_24			=	00456b64h
		_xGameLib_24a			=	00456b64h
		_xGameLib_24b			=	00456b64h
		_xGameLib_24c			=	00456b64h
		_xGameLib_24d			=	00456b64h
		_xGameLib_24e			=	00456b64h
		_xGameLib_25b			=	00456b9ch	;; diff
		_xGameLib_26a			=	00456b9ch	;; diff

		;; end of native reg addr
		_xNatineRegEnd_24		=	6f3da5d1h
		_xNatineRegEnd_24a		=	6f3da5d1h
		_xNatineRegEnd_24b		=	6f3da5d1h
		_xNatineRegEnd_24c		=	6f3da5d1h
		_xNatineRegEnd_24d		=	6f3da631h	;; diff
		_xNatineRegEnd_24e		=	6f3da691h	;; diff
		_xNatineRegEnd_25b		=	6f3d9921h	;; diff
		_xNatineRegEnd_26a		=	6f3d9b51h	;; diff

		;; native reg proc addr
		_xNatineReg_24			=	6f455c00h
		_xNatineReg_24a			=	6f455c00h
		_xNatineReg_24b			=	6f455bc0h	;; diff
		_xNatineReg_24c			=	6f455b60h	;; diff
		_xNatineReg_24d			=	6f455bc0h	;; diff
		_xNatineReg_24e			=	6f455c20h	;; diff
		_xNatineReg_25b			=	6f454ee0h	;; diff
		_xNatineReg_26a			=	6f455110h	;; diff
		;;----------------

	_xStartInfo	STARTUPINFO		sizeof.STARTUPINFO, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, STARTF_USESHOWWINDOW, SW_SHOWNORMAL, ?, ?, ?, ?, ?
	_xProcInfo	PROCESS_INFORMATION	<?>

	_hBuf		=	$
	_sCurDir	du	0100h	dup(?)

	_xVer_war	dd	02h	dup(?)
	_xVer_game	dd	02h	dup(?)

;;-------------------------------------------------------------------------

;;-------------------------------------------------------------------------
section '.rsrc' resource data readable
	directory	RT_VERSION, versions,\
			RT_ICON, icons,\
			RT_GROUP_ICON, group_icons

	resource group_icons, 08h, LANG_NEUTRAL, main_icon

	resource icons,\
			01h, LANG_NEUTRAL, main_ico

	resource versions, 01h, LANG_NEUTRAL, version
			
	versioninfo version, VOS__WINDOWS32, VFT_APP, VFT2_UNKNOWN, LANG_ENGLISH + SUBLANG_DEFAULT, 00h,\
		'FileDescription',	'SWS Murloc Expansion launcher',\
		'FileVersion',		'1.0.14.0',\
		'ProductVersion',	'1.0.14.0',\
		'OriginalFilename',	'xgm.ru',\
		'CompanyName',		'SWS'

	icon main_icon,\
		main_ico, 'main.ico'
;;-------------------------------------------------------------------------